#include "hmg.ch"

/***********************************************************
* DataBase Tables creation
***********************************************************/
FUNCTION CreateTable()
LOCAL oQuery := NIL, cStru := ""

cStru := "CREATE TABLE testtab ( "
cStru += "adminproc Varchar(020) NOT NULL, " // Upd.procedure
cStru += "adminuser Varchar(016) NOT NULL, " // Upd.user
cStru += "admintstp Varchar(017) NOT NULL, " // Upd.timer  aaaammgghhmmssnnn es. 201003121425221
cStru += "progcodec Varchar(008) NOT NULL, " // coe
cStru += "progdescr Varchar(050) NOT NULL, " // description
cStru += "prognumbr Numeric(8,0) NOT NULL, " // last value
cStru += "CONSTRAINT testtab_pkey PRIMARY KEY (progcodec)"
cStru += " );"

IF pboPgCon1:TableExists( "testtab" ) == .T. .AND. MSGYESNO( 'Do you want continue') == .T.
 oQuery := pboPgCon1:Execute( 'DROP TABLE testtab' )
 IF oQuery:NetErr()
  MSGSTOP( HB_VALTOEXP( oQuery:ErrorMsg() ) )
 ENDIF
 oQuery:Destroy()
ENDIF

* esegue la query di creazione
IF pboPgCon1:TableExists( "testtab" ) == .F.
 oQuery := pboPgCon1:Query(cStru)
 IF oQuery:NetErr()
  MSGSTOP( HB_VALTOEXP( oQuery:ErrorMsg() ) )
 ELSE
  Populate()
 ENDIF
 oQuery:Destroy()
ENDIF

RETURN NIL

/***********************************************************
* adding some records
***********************************************************/
STATIC FUNCTION Populate()
LOCAL aQuery := {}, nI := 0, oQuery := NIL, cQuery := "", oRow := NIL
LOCAL cAdminproc := "populate", cAdminuser := pbcUserName, cAdmintstp := HB_TTOS(HB_DATETIME())

AADD( aQuery, "INSERT INTO testtab VALUES ('" + cAdminproc + "','" + cAdminuser + "','" + cAdmintstp + "', 'AACOD001', 'Oranges',   400);" )
AADD( aQuery, "INSERT INTO testtab VALUES ('" + cAdminproc + "','" + cAdminuser + "','" + cAdmintstp + "', 'AACOD002', 'Bananas',   100);" )
AADD( aQuery, "INSERT INTO testtab VALUES ('" + cAdminproc + "','" + cAdminuser + "','" + cAdmintstp + "', 'AACOD003', 'Apples',    2000);" )
AADD( aQuery, "INSERT INTO testtab VALUES ('" + cAdminproc + "','" + cAdminuser + "','" + cAdmintstp + "', 'BBCOD001', 'Cherries',  8000);" )
AADD( aQuery, "INSERT INTO testtab VALUES ('" + cAdminproc + "','" + cAdminuser + "','" + cAdmintstp + "', 'BBCOD002', 'Prunes',    10);" )
AADD( aQuery, "INSERT INTO testtab VALUES ('" + cAdminproc + "','" + cAdminuser + "','" + cAdmintstp + "', 'BBCOD003', 'Pineapple', 0);" )

FOR nI := 1 TO LEN( aQuery )
 oQuery := pboPgCon1:Execute( aQuery[nI] )
 IF oQuery:NetErr()
  MSGSTOP( HB_VALTOEXP( oQuery:ErrorMsg() ) )
 ENDIF
NEXT nI

RETURN NIL
